// MyDialog.cpp : implementation file
//

#include "stdafx.h"
#include "Example6.h"
#include "MyDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyDialog dialog


CMyDialog::CMyDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CMyDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyDialog)
	m_szValue = _T("");
	//}}AFX_DATA_INIT
}


void CMyDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyDialog)
	DDX_Control(pDX, IDC_VALUE, m_CtrlValue);
	DDX_Control(pDX, IDC_REMOVE, m_CtrlRemove);
	DDX_Control(pDX, IDC_ADD, m_CtrlAdd);
	DDX_Control(pDX, IDC_LISTBOX, m_ListBox);
	DDX_Text(pDX, IDC_VALUE, m_szValue);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyDialog, CDialog)
	//{{AFX_MSG_MAP(CMyDialog)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_EN_CHANGE(IDC_VALUE, OnChangeValue)
	ON_LBN_SETFOCUS(IDC_LISTBOX, OnSetfocusListbox)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyDialog message handlers

BOOL CMyDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	MakeCopyForCancel();

	FillListBox();
	
	CenterWindow(); 
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CMyDialog::FillListBox()
{
	CString szTemp; 

	int iResult;
	
	POSITION	pos;

	for (int i=0; i < m_StringList.GetCount(); i++) 
		{
		pos = m_StringList.FindIndex(i);

		szTemp = m_StringList.GetAt(pos); 

		iResult = m_ListBox.AddString(szTemp);
		} 

	iResult = m_ListBox.SetCurSel(0); 

	return TRUE; 
}

void CMyDialog::OnAdd() 
{
	UpdateData(TRUE);
	m_StringList.AddTail(m_szValue);
	m_ListBox.AddString(m_szValue);

	m_szValue = "";
	UpdateData(FALSE);
	
	m_CtrlValue.SetFocus();
	m_CtrlAdd.EnableWindow(FALSE);
}

void CMyDialog::OnChangeValue() 
{
	UpdateData(TRUE);

	if (m_szValue.GetLength())
		m_CtrlAdd.EnableWindow();
	else
		m_CtrlAdd.EnableWindow(FALSE);	
}

BOOL CMyDialog::MakeCopyForCancel()
{
	CString szTemp; 

	POSITION	pos;

	m_iLastValue = m_pLineList->GetCount();

	for (int i=0; i < m_iLastValue; i++) 
		{
		pos = m_pLineList->FindIndex(i);

		szTemp = m_pLineList->GetAt(pos); 

		m_StringList.AddTail(szTemp); 
		} 

	return TRUE;
}

BOOL CMyDialog::MakeCopyForOK()
{
	CString szTemp; 

	m_pLineList->RemoveAll();

	for (int i=0; i < m_ListBox.GetCount(); i++) 
		{
		m_ListBox.GetText(i, szTemp);

		m_pLineList->AddTail(szTemp); 
		} 

	return TRUE;
}

void CMyDialog::OnOK() 
{
	UpdateData(TRUE);

	if (m_szValue.GetLength())
		OnAdd();

	MakeCopyForOK();
	
	CDialog::OnOK();
}

void CMyDialog::OnSetfocusListbox() 
{
	if (m_ListBox.GetCount())
		m_CtrlRemove.EnableWindow();	
}

void CMyDialog::OnRemove() 
{
	CString	szTemp;
	int		iTemp;

	iTemp = m_ListBox.GetCurSel();

	if (iTemp < 0)
		return;

	m_ListBox.GetText(iTemp, szTemp);

	m_ListBox.DeleteString(iTemp);

	if (!m_ListBox.GetCount())
		m_CtrlRemove.EnableWindow(FALSE);
}
